#include "testApp.h"

//--------------------------------------------------------------
void testApp::setup(){
	ofSetFrameRate(120);
	ofSetVerticalSync(true);
	ofEnableAlphaBlending();
	//ofEnableSmoothing();
	ofBackground(0, 0, 0);
	speed=13;
	dir=0;
	x=0;
	y=0;
	
	//setup tiles
	for (int x=0; x<3; x++){
		for (int y=0; y<3; y++){
			tiles[x][y].pic.loadImage("static.jpg");
			tiles[x][y].x=tiles[x][y].pic.width*x;
			tiles[x][y].y=tiles[x][y].pic.height*y;
		}
	}
	
//	//setup dots
//	for (int i=0; i<100; i++){
//		dots[i].x=ofRandom(ofGetWidth());
//		dots[i].y=ofRandom(ofGetHeight());
//	}
	
	//setup timing
	float temp[45]={ 1.86, 1.93, 2.03, 2.7, 3.23, 4.93, 5.1, 5.2, 5.73, 6.26, 6.73, 7.26, 7.86,
		8.3, 8.86, 9.4, 9.8, 10.4, 10.9667, 11.4333, 12.0667, 12.5667, 13.0333,
		13.1333, 13.6333, 13.9667, 14.1, 14.5333, 15.1, 15.6667, 16.1333, 
		20.6333, 20.8333, 21.4, 21.9667, 22.4333, 23.0667, 23.6, 23.9667,
		24.5667, 25.1333, 25.5, 26.1333, 26.5667, 27 };
	//fill timing
	for (int i=0; i<45; i++)
		timing[i]=temp[i];
	
	nextTime=0;
	
	audio.loadSound("audio.mp3");
	started=false;
	
	
}

//--------------------------------------------------------------
void testApp::update(){
	//file is 27.51 sec long
	float curTime=27.51*audio.getPosition();	
	
	//time to start the song?
	if (!started && ofGetElapsedTimef()>3){
		audio.play();
		started=true;
	}
	
	//add the current point
	Circle newCircle;
	newCircle.setup(x+ofGetWidth()/2,y+ofGetHeight()/2);
	circles.push_back(newCircle);
	
	//kill old ones
	while(circles.size()>800)
		circles.erase(circles.begin());
	
	x+=speed*cos(dir);
	y+=speed*sin(dir);
	
	//reset tiles if they're off screen
	for (int xT=0; xT<3; xT++){
		for (int yT=0; yT<3; yT++){
			//shifting right
			if (tiles[xT][yT].x<x-tiles[xT][yT].pic.width)
				tiles[xT][yT].x+=tiles[xT][yT].pic.width*3;
			//shiftung left
			if (tiles[xT][yT].x>x+ofGetWidth())
				tiles[xT][yT].x-=tiles[xT][yT].pic.width*3;
			//shifting down
			if (tiles[xT][yT].y<y-tiles[xT][yT].pic.height)
				tiles[xT][yT].y+=tiles[xT][yT].pic.height*3;
			//shiftung up
			if (tiles[xT][yT].y>y+ofGetHeight())
				tiles[xT][yT].y-=tiles[xT][yT].pic.height*3;
		}
	}
	
	
	//is it time to change directions?
	if (nextTime<45){	//make sure the last hit hasn't hapenned
		if (curTime>=timing[nextTime]){
			dir=ofRandom(TWO_PI);	//new direciton at random
			nextTime++;//advance time
		}
	}

}

//--------------------------------------------------------------
void testApp::draw(){
	//draw 'em!
	ofPushMatrix();
	ofTranslate(-x, -y);
	
	//tiles
	ofSetColor(255, 255, 255);
	for (int x=0; x<3; x++){
		for (int y=0; y<3; y++){
			tiles[x][y].pic.draw(tiles[x][y].x, tiles[x][y].y);
		}
	}
	
//	//dots
//	ofSetColor(200, 200, 200);
//	for (int i=0; i<100; i++){
//		ofCircle(dots[i].x, dots[i].y, 3);
//	}
	
	//draw the outlines
	for (int i=circles.size()-1; i>=0; i--)
		circles[i].drawOutline();
	
	
	//circles
	for (int i=circles.size()-1; i>=0; i--)
		circles[i].draw();
	
	ofPopMatrix();
	
//	ofSetColor(255, 255, 255);
//	testPic.draw(0,0);
		
	

}

//--------------------------------------------------------------
void testApp::keyPressed(int key){
	cout<<key<<endl;
	
	dir=ofRandom(TWO_PI);
	
	if (key==357)	//up
		dir=PI/2;
	if (key==359)	//down
		dir=-PI/2;
	if (key==356)	//left
		dir=0;
	if (key==358)	//right
		dir=PI;
	
	
}

//--------------------------------------------------------------
void testApp::keyReleased(int key){

}

//--------------------------------------------------------------
void testApp::mouseMoved(int x, int y ){

}

//--------------------------------------------------------------
void testApp::mouseDragged(int x, int y, int button){

}

//--------------------------------------------------------------
void testApp::mousePressed(int x, int y, int button){

}

//--------------------------------------------------------------
void testApp::mouseReleased(int x, int y, int button){

}

//--------------------------------------------------------------
void testApp::windowResized(int w, int h){

}

//--------------------------------------------------------------
void testApp::gotMessage(ofMessage msg){

}

//--------------------------------------------------------------
void testApp::dragEvent(ofDragInfo dragInfo){ 

}